VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "www.activevb.de"
   ClientHeight    =   4635
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6360
   LinkTopic       =   "Form1"
   ScaleHeight     =   4635
   ScaleWidth      =   6360
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "Drucken"
      Height          =   495
      Left            =   4680
      TabIndex        =   1
      Top             =   3960
      Width           =   1575
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   3675
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6135
      _ExtentX        =   10821
      _ExtentY        =   6482
      _Version        =   393216
      Cols            =   5
      FixedCols       =   0
      Appearance      =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias _
        "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As _
        Long, ByVal wParam As Long, ByVal lParam As Long) _
        As Long
        
Const WM_USER = &H400
Const VP_FORMATRANGE = WM_USER + 125
Const VP_YESIDO = 456654

Private Type Rect
  Left    As Long
  Top     As Long
  Right   As Long
  Bottom  As Long
End Type

Private Type TFormatRange
  hdc         As Long
  hdcTarget   As Long
  rc          As Rect
  rcPage      As Rect
End Type

Private Sub Command1_Click()
  Call PrintGrid(MSFlexGrid1, 20, 25, 20, 20, _
                 "ActiveVB - FlexGrid drucken ber " & _
                 "VP_FORMATRANGE", "")
End Sub

Private Sub Form_Load()
  Dim Zahl%
  
    'Flex mit irgendwelchen Daten fllen
    With MSFlexGrid1
      .ColWidth(0) = 1000
      .ColWidth(1) = 2000
      .ColWidth(2) = 2600
      .ColAlignment(3) = 0
      .ColWidth(3) = 500
      .ColWidth(4) = 2800
      .TextArray(0) = "Name"
      .TextArray(1) = "E-Mail"
      .TextArray(2) = "HomePage"
      .TextArray(3) = "Nr."
      .TextArray(4) = "Sonstiges"
      
      For Zahl = 1 To 9
        .AddItem "Dirk Lietzow" & vbTab & "dirk@activeVB.de" & _
                 vbTab & "www.activeVB.de" & vbTab & Zahl & vbTab & _
                 "Alle fr einen, einer fr alle ..."
      Next Zahl
      
      ' 1. leere Zeile lschen
      .RemoveItem 1
      
      ' Formatierungsbeispiele
      .Col = 2
      .Row = 2
      .CellFontName = "Arial"
      .CellFontSize = 11
      .Col = 2
      .Row = 3
      .CellFontName = "Arial"
      .CellFontSize = 12
      .Col = 2
      .Row = 4
      .CellFontName = "Arial"
      .CellFontSize = 14
      .CellFontBold = True
      .RowHeight(.Row) = 500
      .Col = 2
      .Row = 6
      .CellBackColor = &H8000000F
      .Col = 2
      .Row = 8
      .CellFontName = "Courier New"
      .CellFontSize = 12
      .CellFontBold = True
      .CellForeColor = vbWhite
      .CellBackColor = &HC00000
      .RowHeight(.Row) = 500
    End With
End Sub

Sub PrintGrid(Grid As MSFlexGrid, ByVal LeftMargin As Single, _
              ByVal TopMargin As Single, ByVal RightMargin As _
              Single, ByVal BottomMargin As Single, Titel As _
              String, Datum As String, Optional many As Integer)
              
  Dim tRange As TFormatRange
  Dim lReturn As Long
  Dim DName As String
  Dim DSchacht As Integer
  Dim gbeg As Long
  Dim CopyCW() As Long
  Dim GRef As Boolean
  Dim X%
  
    GRef = False
    If many > 0 Then
      ' Anzahl der zu druckenden Colums festlegen
      ' Alles > many wird auf colwidth = 0 gesetzt
      If Grid.Cols > many Then
        gbeg = Grid.Cols - many
        ReDim CopyCW(gbeg)
        Grid.Redraw = False
        For X = many To Grid.Cols - 1
          CopyCW(X - many) = Grid.ColWidth(X)
          Grid.ColWidth(X) = 0
        Next X
        GRef = True
      End If
    End If
    
    'mit wParam <> 0 kann berprft werden
    'ob das Control OPP untersttzt, wenn ja wird
    '456654 (VP_YESIDO) zurckgeliefert
    lReturn = SendMessage(Grid.hWnd, VP_FORMATRANGE, 1, 0)
    
    If lReturn = VP_YESIDO Then
      
      'Struktur mit Formatierungsinformationen fllen
      Printer.ScaleMode = vbPixels
      
      With tRange
        .hdc = Printer.hdc
        
        'Hhe und Breite einer Seite (in Pixel)
        .rcPage.Right = Printer.ScaleWidth
        .rcPage.Bottom = Printer.ScaleHeight
        
        'Lage und Abmessungen des Bereichs auf den
        'gedruckt werden soll (in Pixel)
        .rc.Left = Printer.ScaleX(LeftMargin, vbMillimeters)
        .rc.Top = Printer.ScaleY(TopMargin, vbMillimeters)
        .rc.Right = .rcPage.Right - Printer.ScaleX(RightMargin, _
                                                   vbMillimeters)
                                                   
        .rc.Bottom = .rcPage.Bottom - Printer.ScaleY(BottomMargin, _
                                                     vbMillimeters)
      End With
  
      'Drucker initialisieren
      Printer.Print vbNullString
      
      'Seite(n) drucken
      Do
        Printer.CurrentX = Printer.ScaleX(LeftMargin, vbMillimeters)
        Printer.CurrentY = Printer.ScaleY(10, vbMillimeters)
        If Titel <> "" Then Printer.Print Titel
  
        Printer.CurrentX = Printer.ScaleX(LeftMargin, vbMillimeters)
        Printer.CurrentY = Printer.ScaleY(16, vbMillimeters)
        
        If Datum <> "" Then
          Printer.Print Datum
        Else
          Printer.Print Format(Date, "DD.MM.YYYY")
        End If
        lReturn = SendMessage(Grid.hWnd, VP_FORMATRANGE, 0, _
                              VarPtr(tRange))
        
        If lReturn < 0 Then
          Exit Do
        Else
          Printer.NewPage
        End If
      Loop
      Printer.EndDoc
  
      'Reset
      lReturn = SendMessage(Grid.hWnd, VP_FORMATRANGE, 0, 0)
    End If
    
    If GRef Then
      'Alle Colums wieder in richtiger Breite darstellen
      For X = many To Grid.Cols - 1
        Grid.ColWidth(X) = CopyCW(X - many)
      Next X
      Grid.Redraw = True
    End If
End Sub

